{$R+,Q+,I+,S+,F-,M 4096,0,0}
Uses Crt, Dos, SVGA;

Const
  XS = 1;
  YS = 1;
  MaxX = 319;
  MaxY = 128;
  RInc = (390*XS)Div MaxX;
  IInc = (400*YS)Div MaxY;

Var
  Area : Array[0..MaxX+1, 0..MaxY+1]Of Byte;
  pny, py, s,c,d, nx,ny, x,y, xp,yp, x0,y0, cx,tp : Integer;

Begin
  CheckBreak := True;
  SetCBreak(True);

  Write('Drawing fractal...'^M^J'   % completed...'^M);
  yp := -200*YS;
  For y := 0 To MaxY+1 Do
  Begin
    Write(y*100 Div MaxY:3,#13);

    xp := -240*XS;
    For x := 0 To MaxX+1 Do
    Begin
      x0 := 0;
      y0 := 0;
      cx := 0;

      Repeat
        Inc(cx);
        If cx=48 Then Break;

        tp := DivLong(MulLong(x0,x0) - MulLong(y0,y0), 128) + xp;
        y0 := DivLong(MulLong(x0,y0), 64) + yp;
        x0 := tp
      Until MulLong(x0,x0)+MulLong(y0,y0) > 100000;

      Area[x, y] := cx;

      Inc(xp, RInc)
    End;
    Inc(yp, IInc)
  End;

  Set256Mode(320, 200);

  Port[$3C8] := 1;
  For c := 1 To 63 Do {Set palette scale starting from black, till white}
  Begin
    Port[$3C9] := 15+c*32 Div 63;
    Port[$3C9] := c;
    Port[$3C9] := 0;
  End;

  For y := 1 To MaxY Do
    For x := 1 To MaxX Do
    Begin
      c := Area[x,y];

      pny := Area[x,y]-Area[x,y+1];

      If pny>=0 Then
      Begin
        d := (y-Random(2))*63 Div MaxY;
        For py := 71+y-c To 71+y-c+pny Do
          PSet(x,py, d)
      End;

      nx := x-1;
      ny := Area[nx,y];
      s := c-ny;
      pny := 0;

      If s<>0 Then
        Repeat
          If pny < ny Then pny := ny;
          For py := 71+y-pny DownTo 71+y-ny Do
          Begin
            If s>0
              Then c := Point(nx,py)-3
              Else c := Point(nx,py)+3;

            If c<0 Then c:=0;
            If c>63 Then c:=63;
            PSet(nx,py,c)
          End;

          Dec(nx);
          If nx <= 1 Then Break;
          pny := ny;
          ny := Area[nx,y];
          Dec(s, 1+ny-pny)
        Until(s <= 0);

      If KeyPressed Then Break
    End;

  ReadLn
End.